#ifndef __NT_SERVICE_WRAPPER_INCLUDED_H__
#define __NT_SERVICE_WRAPPER_INCLUDED_H__

#include <windows.h>

#include <string>

namespace utils
{
    class CHandleGuard
    {
        HANDLE h_;
        CHandleGuard(CHandleGuard&);
        CHandleGuard& operator=(CHandleGuard&);
    public:
        explicit CHandleGuard(HANDLE h=0)
            :h_(h){}
        ~CHandleGuard(void)
        {
            if(h_)CloseHandle(h_);
        }
        HANDLE get() const {return h_;}
        HANDLE release()
        {
            HANDLE tmp = h_;
            h_ = 0;
            return tmp;
        }
        void reset(HANDLE h)
        {
            if(h_)CloseHandle(h_);
            h_ = h;
        }
        void swap(CHandleGuard & guard)
        {
            reset( guard.release() );
        }

        operator HANDLE() const
        {
            return h_;
        }
    };
}


//////////////////////////////////////////////////////////////////////////

class NtServiceWrapper
{
	SERVICE_STATUS_HANDLE _statusHandle;
	SERVICE_STATUS   _status;
	std::wstring   serviceName_;
	HANDLE stopEvent_;
	HANDLE workThread_;
	utils::CHandleGuard eventGuard_;
	utils::CHandleGuard threadGuard_;
	NtServiceWrapper();
public:
	explicit NtServiceWrapper(const std::wstring& name,
		HANDLE stopEvent, HANDLE workThread);
	void Run();
	BOOL UpdateStatus(DWORD dwState = DWORD(-1),DWORD dwCheckAdd = 0);
	static DWORD WINAPI CtrlHandler(DWORD control, DWORD eventType,
		LPVOID eventData, LPVOID context);
};

#endif