#include "stdafx.h"
#include "InjectDll.h"
#include "Service.h"
#include "common.h"
#include "Win32Utils.h"

namespace
{
    void InitSection()
    {
        std::wstring dll_path(utils::GetCurrModulePath());
        dll_path.append(DLL_NAME);
#ifdef _WIN64
        bool isX64 = true;
#else
        bool isX64 = false;
#endif
        dll_inj::SectionInjecter injecter(isX64, DLL_NAME);
        UNTHROW(injecter.DeleteSection());
        injecter.CreateSection(dll_path);
    }
}


void ServiceMain(int, char**)
{ 
    std::auto_ptr<NtServiceWrapper> service;
    try 
    {
        service.reset(new NtServiceWrapper(SERVICE_NAME, NULL, NULL));
        service->Run();
        InitSection();
    }
    catch(const std::exception& ex)
    {
        std::cout << ex.what();
    }
    if(service.get())
        service->CtrlHandler(SERVICE_STOPPED, NULL, NULL, service.get());
    return;
}