// HookLib.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "redirection.h"
#include "stubs.h"
#include "common.h"
#include <algorithm>
namespace
{
    PSEND       g_pSend     = NULL;
    PRECV       g_pRecv     = NULL;
    
    template<typename T>
    void InitAddr(T& destAdrr, LPCSTR funcName, HMODULE hModule)
    {
        destAdrr = (T)GetProcAddress(hModule, funcName);
        CHECK_ADDRESS(destAdrr);
    }
  
    
    static const char searchString[] =  "Wrong_code";
    static const char replaceString[] = "Cool_code!";


    void SearchAndReplace( const char* res, const char FAR * buf, int len )
    {
        for(;;)
        {
            res = std::search(res, buf+len, &searchString[0], &searchString[0] + MAXSTRINGLEN(searchString));
            if (res < buf+len)
            {
                memcpy(const_cast<char*>(res), replaceString, MAXSTRINGLEN(replaceString));
            }
            else
            {
                break;
            }
        }	
    }
}

void Init(HMODULE hModule)
{
    InitAddr(g_pSend, "send", hModule);
    InitAddr(g_pRecv, "recv", hModule);
}

int 
WINAPI 
_send(SOCKET s, const char FAR *buf, int len, int flags)
{
    const char* res = buf; 
    SearchAndReplace(res, buf, len);

    return g_pSend(s, buf, len, flags);
}

int
WINAPI
_recv(SOCKET s, const char FAR *buf, int len, int flags)
{
    const char* res = buf; 
    SearchAndReplace(res, buf, len);

    return g_pRecv(s, buf, len, flags);
}
